Skip site navigation (1)Skip section navigation (2)
Date:      Tue, 28 Feb 2012 08:36:38 +0000 (UTC)
From:      Peter Holm <pho@FreeBSD.org>
To:        src-committers@freebsd.org, svn-src-projects@freebsd.org
Subject:   svn commit: r232248 - projects/stress2/misc
Message-ID:  <201202280836.q1S8acnY060112@svn.freebsd.org>

next in thread | raw e-mail | index | archive | help
Author: pho
Date: Tue Feb 28 08:36:38 2012
New Revision: 232248
URL: http://svn.freebsd.org/changeset/base/232248

Log:
  New nullfs scenario added.
  
  PR:		kern/164261

Added:
  projects/stress2/misc/nullfs8.sh   (contents, props changed)

Added: projects/stress2/misc/nullfs8.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ projects/stress2/misc/nullfs8.sh	Tue Feb 28 08:36:38 2012	(r232248)
@@ -0,0 +1,66 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2012 Peter Holm <pho@FreeBSD.org>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Based on scenario by rea@, kern/164261. Different panic.
+# insmntque: mp-safe fs and non-locked vp: 0xcb413984 is not exclusive
+# locked but should be
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+opt="-o nfsv3,rw,udp,rdirplus,noauto"
+
+mount | grep -wq $mntpoint && umount $mntpoint
+mount -t nullfs /tmp $mntpoint
+
+mntpoint2=${mntpoint}2
+mntpoint3=${mntpoint}3
+for m in $mntpoint2 $mntpoint3; do
+	[ -d $m ] || mkdir $m
+	mount | grep -wq $m && umount $m
+	mount -t nfs $opt 127.0.0.1:$mntpoint $m
+done
+
+for i in `jot 50` ; do
+	su $testuser -c "cp -r /usr/include $mntpoint2/nullfs8-2 2>/dev/null" &
+	su $testuser -c "cp -r /usr/include $mntpoint3/nullfs8-2 2>/dev/null" &
+	wait;wait
+	su $testuser -c "find $mntpoint2 > /dev/null 2>&1" &
+	su $testuser -c "find $mntpoint3 > /dev/null 2>&1" &
+	wait;wait
+	rm -rf /tmp/nullfs8-2
+done
+
+for m in $mntpoint3 $mntpoint2 $mntpoint; do
+	while mount | grep -wq $m;  do
+		umount $m || sleep 1
+	done
+done



Want to link to this message? Use this URL: <https://mail-archive.FreeBSD.org/cgi/mid.cgi?201202280836.q1S8acnY060112>